; --- Sound definitions ---
;Calculating labels used by player

;Sound definition constants
#define akeep ars
#define skeep sls
#define vkeep vos

;Sound definition macro
#define snddef(AR,SL,VO) .byte AR-ars \ .org $ + sounds-1
#defcont \ .byte SL-sls \ .org $ + sounds-1
#defcont \ .byte VO-vos \ .org $ - (2 * sounds)

; --- Arpeggio program ---

;Command macros
#define  ar(x,y) .byte x-1 \ .org $+arlen-1 \ .byte y \ .org $-arlen
#define  ajmp(x) .byte $ff \ .org $+arlen-1 \ .byte x-ar0 \ .org $-arlen
#define  astop ajmp(ar0)

; --- Slide program ---
#define  sl(x,y) .byte x-1 \ .org $+sllen-1 \ .byte y \ .org $-sllen
#define  sjmp(x) .byte $ff \ .org $+sllen-1 \ .byte x-sl0 \ .org $-sllen
#define  sstop sjmp(sl0)

; --- Volume program ---

;Command macros
#define  vo(x,y) .byte x-1 \ .org $+volen-1 \ .byte y \ .org $-volen
#define  vjmp(x) .byte $ff \ .org $+volen-1 \ .byte x-vo0 \ .org $-volen
#define  vstop vjmp(vo0)

;--- Track commands ---

#define sct(x) .byte x-sctas
#define t0jmp(x) .byte $ff, x-trk0
#define t1jmp(x) .byte $ff, x-trk1
#define trans(x) .byte $80+x

;--- Sector address definition
;Sector definition macro
#define sctdef(x) .byte LO(x) \ .org $+sctalen-1 \ .byte HI(x) \ .org $-sctalen

;--- Sector commands ---
;
#define snd(x) .byte $c0+x-defs
#define dur(x) .byte $7f+x
#define fin .byte $7f
#define off .byte $7e
#define keep .byte $7d

; + Notes
#define  C0 .byte 0
#define  C#0 .byte 1
#define  D0 .byte 2
#define  D#0 .byte 3
#define  E0 .byte 4
#define  F0 .byte 5
#define  F#0 .byte 6
#define  G0 .byte 7
#define  G#0 .byte 8
#define  A0 .byte 9
#define  A#0 .byte 10
#define  B0 .byte 11

#define  C1 .byte 12
#define  C#1 .byte 13
#define  D1 .byte 14
#define  D#1 .byte 15
#define  E1 .byte 16
#define  F1 .byte 17
#define  F#1 .byte 18
#define  G1 .byte 19
#define  G#1 .byte 20
#define  A1 .byte 21
#define  A#1 .byte 22
#define  B1 .byte 23

#define  C2 .byte 24
#define  C#2 .byte 25
#define  D2 .byte 26
#define  D#2 .byte 27
#define  E2 .byte 28
#define  F2 .byte 29
#define  F#2 .byte 30
#define  G2 .byte 31
#define  G#2 .byte 32
#define  A2 .byte 33
#define  A#2 .byte 34
#define  B2 .byte 35

#define  C3 .byte 36
#define  C#3 .byte 37
#define  D3 .byte 38
#define  D#3 .byte 39
#define  E3 .byte 40
#define  F3 .byte 41
#define  F#3 .byte 42
#define  G3 .byte 43
#define  G#3 .byte 44
#define  A3 .byte 45
#define  A#3 .byte 46
#define  B3 .byte 47

#define  C4 .byte 48
#define  C#4 .byte 49
#define  D4 .byte 50
#define  D#4 .byte 51
#define  E4 .byte 52
#define  F4 .byte 53
#define  F#4 .byte 54
#define  G4 .byte 55
#define  G#4 .byte 56
#define  A4 .byte 57
#define  A#4 .byte 58
#define  B4 .byte 59

         .end
